﻿@model eCommerce.Services.Model.USER
@{
    ViewBag.Title = "Operadores";
    Layout = "~/Views/Shared/_Layout.cshtml";
}


<div class="page-header">
    <h1 class="page-title">Operadores</h1>
    <ol class="breadcrumb">
        <li class="active">Crear / Editar</li>
    </ol>
</div>

<div class="page-content">
    <div class="panel">
        <div class="panel-body">
            <div class="col-md-12">
                <div id="example">
                    @using (Html.BeginForm("OperatorUpdate", "Operators", FormMethod.Post, new { @class = "form-horizontal", @autocomplete = "off" }))
                    {
                        <div class="form-group">
                            <label class="col-sm-2 control-label">Nombre y Apellido</label>
                            <div class="col-sm-9">
                                <input type="text" class="form-control" name="Fullname" value="@Model.Fullname" />
                            </div>
                        </div>
                        <div class="form-group">
                            <label class="col-sm-2 control-label">Email</label>
                            <div class="col-sm-9">
                                <input type="text" class="form-control" name="Email" value="@Model.Email" />
                            </div>
                        </div>
                        <div class="form-group">
                            <label class="col-sm-2 control-label">Username</label>
                            <div class="col-sm-9">
                                <input type="text" class="form-control" name="Username" value="@Model.Username" />
                            </div>
                        </div>
                        <div class="form-group">
                            <label class="col-sm-2 control-label">Password</label>
                            <div class="col-sm-9">
                                <input type="text" class="form-control" name="Password" value="@Model.Password" />
                            </div>
                        </div>
                        <div class="form-group">
                            <label class="col-sm-2 control-label">Activo</label>
                            <div class="col-sm-9">
                                <div class="checkbox-custom checkbox-primary">
                                    <input type="checkbox" id="Enabled" name="Enabled" class="js-switch-small" data-plugin="switchery" data-size="small" @( Model.Enabled ? "checked" : "") />
                                </div>
                            </div>
                        </div>
                        if (ViewContext.Controller.HasRole("SuperAdmin"))
                        {
                            <div class="form-group">
                                <label class="col-sm-2 control-label">Depositos</label>
                                <div class="col-sm-9">
                                    <select id="Deposits" name="DepositsId" multiple="multiple" style="width:100%;">
                                        @if (TempData["Deposits"] != null)
                                        {
                                            foreach (var item in (MultiSelectList)TempData["Deposits"])
                                            {
                                                <option value="@item.Value" selected="@item.Selected">@item.Text</option>
                                            }
                                        }
                                    </select>
                                </div>
                            </div>
                        }


                        <div class="text-right">
                            <button type="submit" class="btn btn-primary btn-success" id="btnSave">Grabar</button>
                            <button type="button" class="btn btn-default" onclick="window.location.href = '/Operators'">Cancelar</button>
                            @Html.HiddenFor(model => model.User_Id)
                        </div>
                    }
                </div>
            </div>
            @if (Model.User_Id > 0)
            {
                <div class="col-lg-12">
                    <div class="example">
                        <h4 class="example-title">Roles asociados a este Usuario</h4>
                        <div class="form-horizontal">
                            <div class="form-group">
                                <label class="col-sm-1 control-label">Roles</label>
                                <div class="col-sm-5">
                                    <select class="form-control" name="RoleId" id="RoleId" data-plugin="select2">
                                        <option value=""></option>
                                        @if (TempData["Roles"] != null)
                                        {
                                            foreach (var item in (SelectList)TempData["Roles"])
                                            {
                                                <option value="@item.Value" selected="@item.Selected">@item.Text</option>
                                            }
                                        }
                                    </select>
                                </div>
                                <div class="col-sm-1">
                                    <button type="button" class="btn btn-outline btn-primary" id="AddRole">
                                        <i class="icon wb-plus" aria-hidden="true"></i>
                                        <span class="hidden-xs">Asignar</span>
                                    </button>
                                </div>
                            </div>
                            <div class="col-sm-9" id="RolesTable">
                                @Html.Partial("_UserRoleListEdit", Model.ROLES)
                            </div>
                        </div>
                    </div>
                </div>
            }
        </div>
    </div>
</div>

@section Scripts {

    <script type="text/javascript">

            (function () {
                $('.form-horizontal').formValidation({
                    framework: "bootstrap",
                    button: {
                        selector: '#btnSave',
                        disabled: 'disabled'
                    },
                    icon: null,
                    fields: {
                        Fullname: {
                            validators: {
                                notEmpty: {
                                    message: 'El campo Nombre y Apellido es requerido.'
                                }
                            }
                        },
                        Email: {
                            validators: {
                                notEmpty: {
                                    message: 'El campo Email es requerido.'
                                },
                                emailAddress: {
                                    message: 'El email ingresado es inválido.'
                                }
                            }
                        },
                        Username: {
                            validators: {
                                notEmpty: {
                                    message: 'El campo Username es requerido.'
                                }
                            }
                        },
                        Password: {
                            validators: {
                                notEmpty: {
                                    message: 'El campo Password es requerido.'
                                }
                            }
                        }
                    }
                });
            })();


            $(document).ready(function ()
            {
                $('#AddRole').click(function ()
                {
                    var _userId = $('#User_Id').val();
                    var _id = $('#RoleId').val();


                    var _parameters = { userId: _userId, id: _id };
                    $.ajax({
                        url: "/Operators/AddUserRole",
                        type: "GET",
                        data: _parameters,
                        success: function (data, textStatus, jqXHR)
                        {
                            $('#RolesTable').html(data);
                            setActionsDialogs();
                        }
                    });
                });

                $("#Deposits").select2();
            });

        /****************** LISTADO DE ROLES - PARTIAL VIEW FUNCTIONS ***********************/    

            $(document).ready(function () {
                setActionsDialogs();
            });

            function fDelete(Id) 
            {
                var _userId = $('#User_Id').val();
                var _parameters = { userId: _userId, id: Id };

                if (_userId == '') {
                    return false;
                }

                $.ajax({
                    url: "/Operators/DeleteUserRole",
                    type: "GET",
                    data: _parameters,
                    success: function (data, textStatus, jqXHR) {
                        $('#RolesTable').html(data);
                        setActionsDialogs();
                        swal("Eliminado!", "", "success");
                    }
                });
            }

            function setActionsDialogs() {

                $('.remove-row').on("click", function () {
                    var rowId = $(this).attr("data-rowid");

                    swal({
                        title: "Confirma su acción de Eliminar?",
                        text: "",
                        type: "warning",
                        showCancelButton: true,
                        confirmButtonColor: '#F26A54',
                        confirmButtonText: 'Sí, deseo elminarlo!',
                        cancelButtonText: 'Cancelar',
                        closeOnConfirm: false,
                        closeOnCancel: true
                    },
                    function (isConfirm) {
                        if (isConfirm) {
                            fDelete(rowId);
                        }
                    });
                });
            }

        </script>
}

